import IQuillCursorsOptions from './i-quill-cursors-options';
import Cursor from './cursor';
import IQuillRange from './i-range';
export default class QuillCursors {
    static DEFAULTS: IQuillCursorsOptions;
    readonly quill: any;
    readonly options: IQuillCursorsOptions;
    private readonly _cursors;
    private readonly _container;
    private readonly _boundsContainer;
    private _currentSelection;
    private _isObserving;
    constructor(quill: any, options?: IQuillCursorsOptions);
    createCursor(id: string, name: string, color: string): Cursor;
    moveCursor(id: string, range: IQuillRange): void;
    removeCursor(id: string): void;
    update(): void;
    clearCursors(): void;
    toggleFlag(id: string, shouldShow?: boolean): void;
    cursors(): Cursor[];
    private _registerSelectionChangeListeners;
    private _registerTextChangeListener;
    private _registerDomListeners;
    private _registerResizeObserver;
    private _updateCursor;
    private _indexWithinQuillBounds;
    private _leafIsValid;
    private _handleTextChange;
    private _emitSelection;
    private _setDefaults;
    private _lineRanges;
    private _transformCursors;
}
